#FastScan .csv file analysis. Requires scan rate (degrees/sec) as a user input
# KA1GT and DL3WDG  decomber 2024

###############################################################################################################
######## NOTE. This is crude development code, provided for interest only. It works fine with the right inpus but it doesn't
######## do a lot of sanity checking on user input, or does it do things the best or most elegant way. It has NOT been
######## cleaned up or optimized. It may contain errors. It is not offered as supported code suitable for distribution
######## Use it at you own risk! A better version MAY appear one day.
################################################################################################################

clear all
close all
clc
pkg load data-smoothing
scrsz=get(0,'Screensize');
hpix=scrsz(3); % number of horizontal screen pixels
vpix=scrsz(4); % number of vertical screen pixels

##################################################################################
### KA1GT "pre-processing" routine to determin data collection rate (points per second)
### find index values and strength for left sidelope and right sidelobe
##################################################################################

#  looks for data rate in SpectraVue continuum data - KA1GT
#  NOTE - Requires data/time format to be YYYY-MM-DD HH:MM:SS e.g. 2024-04-20 16:30:05
# This is the default for SpectraVue contimuum files.
#  A  continuum data recording time of at least 21s is required, since data point frequency is measured over a 20s interval.

[filename,pathname]=uigetfile('*.csv','Select SepctaVue csv file'); #select input .csv file
File_Path=strcat(pathname,filename) # create full path to file

fid = fopen (File_Path); # open the file for reading/writing
################################# code for <10 hours UTC time###################################
CSV_Line = fgetl(fid) ;# get first line of csv file date time, level, level
[Date_Time,rest_of_line] = strtok(CSV_Line, ",") ;# date time is before first comma
[CSV_Levels,CSV_Time] = strtok(Date_Time); ## Split at space
CSV_Time=strtrim(CSV_Time) ; ## remove leading space
        if (length(CSV_Time) ==7 ) # if hours <10
                CSV_Time = strcat("0",CSV_Time) # add a leading sero
        endif
Hours = substr(CSV_Time,1,2);
Mins = substr(CSV_Time,4,2);
Secs = substr(CSV_Time,7,2);
Time_spm =  (str2double (Hours)*60*60) +  (str2double (Mins)*60) +  (str2double (Secs)) ; #This is the time in seconds after midnight UTC. If scan includes mignight, won't work!!

#Time_spm is seconds after midnight UTC of the first data point. Don't make a scan that crosses 00:00:00 UTC or the time calculation WILL fail!

NextTime=Time_spm; # Initialize variable Time in Seconds Past Midnight when the file starts
Index_Count=0;

while NextTime == Time_spm  #read lines untill the time changes (i.e. seconds change). This will be the start of the timing count
    Index_Count = Index_Count+1;
    CSV_Line = fgetl(fid) ;# get first line of csv file date time, level, level
[Date_Time,rest_of_line] = strtok(CSV_Line, ","); # date time is before first comma
[CSV_Levels,CSV_Time] = strtok(Date_Time) ;## Split at space
CSV_Time=strtrim(CSV_Time) ; ## remove leading space
        if (length(CSV_Time) ==7 );# if hours <10
                CSV_Time = strcat("0",CSV_Time) ;# add a leading sero
        endif
Hours = substr(CSV_Time,1,2);
Mins = substr(CSV_Time,4,2);
Secs = substr(CSV_Time,7,2);
NextTime =  (str2double (Hours)*60*60) +  (str2double (Mins)*60) +  (str2double (Secs))  #This is the time in seconds after midnight UTC. If scan includes mignight, won't work!!
endwhile

First_Time_Index = Index_Count + 1 #start of of the section in which to count data points

Time_spm2 = Time_spm+21 #look for end of time block which is 20s into the future

while NextTime != Time_spm2
        Index_Count = Index_Count+1;
         CSV_Line = fgetl(fid) ;# get first line of csv file date time, level, level
        [Date_Time,rest_of_line] = strtok(CSV_Line, ",") ;# date time is before first comma
        [CSV_Levels,CSV_Time] = strtok(Date_Time) ;## Split at space
        CSV_Time=strtrim(CSV_Time) ; ## remove leading space
             if (length(CSV_Time) ==7 );# if hours <10
                CSV_Time = strcat("0",CSV_Time) ;# add a leading sero
             endif
        Hours = substr(CSV_Time,1,2);
        Mins = substr(CSV_Time,4,2);
        Secs = substr(CSV_Time,7,2);
        NextTime =  (str2double (Hours)*60*60) +  (str2double (Mins)*60) +  (str2double (Secs))  #This is the time in seconds after midnight UTC. If scan includes mignight, won't work!!
endwhile


Secong_Time_Index = Index_Count+1 # this is the sart point of data taken 20s after the start point.

fclose (fid); # close file, stop sequetial reading of file lines and reset index back to start for any future reads

# in 20s there were Last_time - First_Time_Index readings
Datapoints_per_Second = (Secong_Time_Index - First_Time_Index)/20


#####  LOOP BACK TO THIS POINT####KA1GT #############

 while 1==1  ## KA1GT ## loop forever (exit oportunity at end ########. Permits multiple analysis of file without reloading.

                #Now plot the data (and the smoothed data, to check it's OK ) and locate the index numbers of required data points (start and syop of valid date, position of fide lobes)

                csv_Data=csvread (File_Path);    #reads in csv data
                Data_Length=length(csv_Data); #Number of data points

                x_vector = [1:Data_Length]';  # Create an x axis vector for smoothing function. The ' transposes the vector from row to column

                signal_dB = csv_Data(:,2);     # get a vector of the SpectraVue continuum values for use by the smoothing function

                #Smoothe the data to remove noise but keep original shape by using an appropriate value of Lambda. Higher lambda gives smoother curce put may not follow small changes
               [smdata, lambda1] = regdatasmooth (x_vector, signal_dB, "lambda", 1e-09); # Lambda adjusts the degree of smoothing. For this data 0.0000001 seems good

                figure(10); # Plot smothed data on top of raw data to check all looks good
                title (File_Path);
                hold on
                plot(signal_dB, "linewidth",1,"color","k");
                plot (smdata, "linewidth",2, "color", "r");
                #plot (smdata2, "linewidth", 2, "color", "r");

                ########## ROUTINE TO GET NEW COORDINATES FROM A PLOT  ########

                msgbox ("AFTER CLOSING THIS WINDOWS\nmouse over first data pointand and left click\nmouseover first sidelobe peak and left click\nmouseover second sidelope peak and left clicjr\nmouseover last data point and left click");
                [side_x, side_y] = ginput (4); # get 4 sets of coorinates before continuing

                # Out of Bounds Checks.  Puttingthe sursor to the left of the data points  and to the right of the data points will not change data span.
                if (side_x(1) <1)
                  side_x(1) =1
                endif
                if (side_x(4) > Data_Length)
                  side_x(4) = Data_Length
                endif

                Start_Data = round(side_x(1))
                Left_Sidelobe = round(side_x(2))
                Right_Sidelobe = round(side_x(3))
                Stop_Data = round (side_x(4))

                Left_Sidelobs_Index = round(side_x(2)) - round(side_x(1))
                Right_Sidelobe_Index = round(side_x(3)) - round(side_x(1))

                msg_line1 = strcat ("data points per second = ", num2str(Datapoints_per_Second));
                msg_line2 = strcat ("New first data point index = ",num2str(Start_Data));
                msg_line3 = strcat ("New left sidelobe index = ", num2str(Left_Sidelobs_Index));
                msg_line4 = strcat ("New right sidelobe index = ", num2str(Right_Sidelobe_Index));
                msg_line5 = strcat ("last data point index = ", num2str(Stop_Data));

                waitfor(msgbox({msg_line1,msg_line2,msg_line3,msg_line4,msg_line5}, File_Path));


                 wfn=File_Path; #Passing KA1GT variable name to DL3WDG variable name.

                 S1=csvread (wfn,0,1);  # reads in csv data ignoring troublesome time field. Creates a 2 column matrix
                 S=S1(Start_Data:Stop_Data) ' ; #'#Now select the data to be used  into a vector.  ###KA1GT### I have no idea why this has to be transposed (  '  ).

 fid = fopen (File_Path); # open the file for reading/writing
xdt=1 #initialize index

while (! feof (fid) )  # fill arays (vectors) with data from text time. feo(fid) is the End Of File marger for the file identified by fid

            get_Line = fgetl(fid) # get first line of csv file date time, level, level

            # parse each line of data
            [Date_Time,rest_of_line] = strtok(get_Line, ",") ;# date time is before first comma

            #Load tata in to vectors, string for Time/Date, numbers for relative azimuth and relative tme
            DT{xdt} = Date_Time; # puts Date/Time string in cell array

            # Note:To extract data from DT use  DT {[3440]}  gets time as string at the given index value (3440)

            xdt=xdt+1

endwhile

fclose(fid) #close fikle abd reset index to start for line reads
DT2 = {DT{Start_Data:Stop_Data}} # creates a new cell array with part of the contents of the original

#Now you can find the Spectravue timestamp corresponding to the peaks and the profile widths ftom the vector index
# HOWEVER, SpectraVue only records integer seconds , so the for real time you have to interpolare,


                Length=length(S);%no of lines of input data
                Length
                prompt = {'*Points/sec', 'deg/sec', '*lower sidelobe index', '*upper sidelobe index','el (0 if vertical scan)','smoothing (0-3)', 'Sky Noise (0=use csv data)'};
                   dlg_title = 'Input parameters - DL3WDG';
                   #defaultans = {'93.75','0.75','316','580','42',}; #############commented out KA1GT#######################
                   defaultans = {num2str(Datapoints_per_Second),'1.611',num2str(Left_Sidelobs_Index),num2str(Right_Sidelobe_Index),'27.6','1','0'};#########changed by KA1GT###############
                   answer = inputdlg(prompt,dlg_title,[1 11; 1 11; 1 11; 1 11; 1 11;1 11;1 11],defaultans);

                   pointspsec = str2num(answer{1});
                   degspsec = str2num(answer{2});
                   Lsidelobeindex= int32(str2num(answer{3}));
                   Usidelobeindex= int32(str2num(answer{4}))
                   %time1=datevec(answer(4));
                   %az1 = str2num(answer{5});
                   elevation = str2num(answer{5});
                   %time2=datevec(answer(7));
                  % az2=str2num(answer{8});
                 %  elevation2 = str2num(answer{9});

                 smoothing = (answer{6}) # KA1GT smoothing parametsr (leave as string)
                 Sky_Noise = str2num((answer{7})); # optional sky noise value  ## KA1GT ##

                 Degrees_per_Datapoint = degspsec/Datapoints_per_Second

                 azppoint=(degspsec/pointspsec); # critical step that turns point index to degrees
                %azppoint=(degspsec/pointspsec);
                h=figure; % GUI for plot
                set(h,'Name','Half Drift Scan analysis by DL3WDG','NumberTitle','off','Menubar','Figure','Position',[round(0.04*hpix) round(0.42*vpix) round(0.44*hpix) round(0.44*vpix)])

                # Change smoothing coefficient 1 is normally OK,  2 to 4 are smoother, but may niss rapidly changing data  ### KA1GT ###
                smoothing # confirm value of smoothing
                if (str2num(smoothing)==1)
                sc = 1E-7
                elseif (str2num(smoothing)==2)
                sc=1E-6
                elseif(str2num(smoothing)==3)
                sc=1e-5
                elseif(str2num(smoothing)==4)
                sc=1e-4
                elseif(str2num(smoothing)==0)
                sc=1e-8
                else sc=1E-7 # default if invalid number is typed
                endif

                x_vector = [1:Length]'; #create and transpose vestor
                [Ns, lambda3] = regdatasmooth (x_vector, S, "lambda", sc); ### S is a vector, so no need to manupulate it???  ###KA1GT######


                [peak,ipeak] = max(Ns)%peak is peak value and ipeak is its index

                [Min_Noise, imin] = min(Ns) # look for the minimum noise level  ### KA1GT ### Only used to plot minimum noise line on plot

                xaxis=0; %used for plotting
                startnoise=0;
                endnoise=0;
                normnoise=0;
                normnoise2=0;
                avendnoise=0;

                % this loop gets average noise level at end of data from 51 points
                for i=(Length-51):(Length-1)
                %for i=950:1000
                endnoise=endnoise+Ns(i);
                endfor
                avendnoise=endnoise/51  %gets averaged noise level at start of test

               ### KAIGT  #####  averge 50 lowest values ratherthan last 50 values
               [sortedVals] = sort(Ns); # sort in ascending order
               lowavenoise = sum (sortedVals(1:50))/50 # averge the lowest 50 points

                % this loop gets average noise level at START of data from 51 points
                for i=(5:55)
                     startnoise=startnoise+Ns(i);
                endfor
               avstartnoise=startnoise/51  %gets averaged noise level at start of test

               normfact=(10^(peak/10)-10^(avendnoise/10))

                for i=1:Length%looking in left hand part of data
                normnoisefull(i,:)=(10^(Ns(i)/10)-10^(avendnoise/10))/normfact;%column vector of normalised noise data

                endfor
                xaxis=linspace(1,Length*1,Length); % generates the x-axix for the plots
                %length(xaxis); was a diagnostic

                for i=1:ipeak%looking in left hand part of data
                normnoise(i,:)=(10^(Ns(i)/10)-10^(avstartnoise/10))/normfact;%column vector of normalised noise data
                endfor
                %normnoise(498)

                target = 0.15;%searching for point in normalised data to match value of 0.15 for Joachim tool
                Index=find(min(abs(normnoise-target))==abs(normnoise-target));%returns index of this value
                normnoise(Index);
                L15=Index%is index of lower 0.15 match

                target = 0.2;%searching for a specific value
                Index=find(min(abs(normnoise-target))==abs(normnoise-target));%returns index of this value
                normnoise(Index);
                L2=Index%is index of lower 0.2 match

                target = 0.3;%searching for a specific value
                Index=find(min(abs(normnoise-target))==abs(normnoise-target));%returns index of this value
                normnoise(Index);
                L3=Index%is index of lower 0.3 match

                target = 0.7;%searching for a specific value
                Index=find(min(abs(normnoise-target))==abs(normnoise-target));%returns index of this value
                normnoise(Index);
                L7=Index%is index of lower 0.7 match

                target = 0.8;%searching for a specific value
                Index=find(min(abs(normnoise-target))==abs(normnoise-target));%returns index of this value
                normnoise(Index);
                L8=Index%is index of lower 0.8 match

                target = 0.85;%searching for a specific value
                Index=find(min(abs(normnoise-target))==abs(normnoise-target));%returns index of this value
                normnoise(Index);
                L85=Index%is index of lower 0.85 match

                target = 0.5;%searching for a specific value (the -3dB point for crude HPBW)
                Index=find(min(abs(normnoise-target))==abs(normnoise-target));%returns index of this value
                normnoise(Index);
                L5=Index%is index of lower 0.85 match

                LDiff15=L85-L15%is difference between lower 0.2 and 0.8 matches
                LDiff2=L8-L2%is difference between lower 0.2 and 0.8 matches
                LDiff3=L7-L3%is difference between lower 0.2 and 0.8 matches

                for i=ipeak:Length%searching right side of peak
                normnoise2(i,:)=(10^(Ns(i)/10)-10^(avstartnoise/10))/normfact;
                endfor
                %%normnoise(498)

                target = 0.15;%searching for a specific value
                Index=find(min(abs(normnoise2-target))==abs(normnoise2-target));%returns index of this value
                normnoise2(Index);
                U15=Index

                target = 0.2;%searching for a specific value
                Index=find(min(abs(normnoise2-target))==abs(normnoise2-target));%returns index of this value
                normnoise2(Index);
                U2=Index

                target = 0.3;%searching for a specific value
                Index=find(min(abs(normnoise2-target))==abs(normnoise2-target));%returns index of this value
                normnoise2(Index);
                U3=Index

                target = 0.7;%searching for a specific value
                Index=find(min(abs(normnoise2-target))==abs(normnoise2-target));%returns index of this value
                normnoise2(Index);
                U7=Index

                target = 0.8;%searching for a specific value
                Index=find(min(abs(normnoise2-target))==abs(normnoise2-target));%returns index of this value
                normnoise2(Index);
                U8=Index

                target = 0.85;%searching for a specific value
                Index=find(min(abs(normnoise2-target))==abs(normnoise2-target));%returns index of this value
                normnoise2(Index);
                U85=Index

                target = 0.5;%searching for a specific value
                Index=find(min(abs(normnoise2-target))==abs(normnoise2-target));%returns index of this value
                normnoise2(Index);
                U5=Index

                UDiff15=U15-U85
                UDiff2=U2-U8
                UDiff3=U3-U7

                UL5=U5-L5

                corrazppoint=azppoint*cosd(elevation);

               ## KA1GT ## Option to enter sky noise value
                if (Sky_Noise != 0) # if Sky Noise is enterd, use it
                Sunnoise_maxYdB=peak-Sky_Noise # KA1GT If Sky Noise is entered, use it
                else # Otherwise use noise from csv end
                Sunnoise_maxYdB=peak-avendnoise
                endif

                ##  KA1GT calculate sun noise using minimum noise
                if (Sky_Noise != 0) # if Sky Noise is enterd, use it
                Sunnoise_maxYdB=peak-Sky_Noise # KA1GT If Sky Noise is entered, use it
                else # Otherwise use minimum noise from snoothed csv
                Sunnoise_maxYdB2=peak-Min_Noise
                endif

                %CrudeHPBW_L=(ipeak-L5)*corrazrate*2%crude HPBW from first half of scan
                Crude1DbBW =(U8-L8)*corrazppoint% crude1dB beamwidth from full scan
                CrudeHPBW=(U5-L5)*corrazppoint% crude HPBW from full scan
                joachim_15L=LDiff15*corrazppoint% from first half of scan
                joachim_2L=LDiff2*corrazppoint% from first half of scan
                joachim3_L=LDiff3*corrazppoint% from first half of scan
                joachim_15U=UDiff15*corrazppoint% from first half of scan
                joachim_2U=UDiff2*corrazppoint% from first half of scan
                joachim_3U=UDiff3*corrazppoint% from first half of scan


                Lsidelobelevel_dB=10*log10(normnoisefull(Lsidelobeindex))
                Usidelobelevel_dB=10*log10(normnoisefull(Usidelobeindex))

                figure(1); % plots in GUI

                plot((xaxis),normnoisefull(1:Length)); % plot one cho linear spectrum
                line ([0 (length(xaxis))], [0.15 0.15], "linestyle", "-", "color", "r");
                line ([0 (length(xaxis))], [0.2 0.2], "linestyle", "-", "color", "r");
                line ([0 (length(xaxis))], [0.3 0.3], "linestyle", "-", "color", "r");
                line ([0 (length(xaxis))], [0.5 0.5], "linestyle", "-", "color", "r");
                line ([0 (length(xaxis))], [0.7 0.7], "linestyle", "-", "color", "r");
                line ([0 (length(xaxis))], [0.8 0.8], "linestyle", "-", "color", "r");
                line ([0 (length(xaxis))], [0.85 0.85], "linestyle", "-", "color", "r");
                %plot (L15,0.15,"g*");
                ylim([0.0 1]);
                title ("Normalised level");
                xlabel ("Data Points");
                ylabel ("Level");
                % plot (L15,0.15,"g*");
                grid on;

                figure(2); % plots in GUI
                hold on
                plot((xaxis),Ns(1:Length),'linewidth',3); % plot one cho linear spectrum
                plot((xaxis),S(1:Length),'linewidth',2); % plot unsmoothed data  KA!GT

                line ([1 length(Ns)] , [ lowavenoise lowavenoise], "linestyle", "-", "color", "b"); ## KA1GT ### Horizontal line at averge minimum value (dB plot)


                title ("Raw noise data");
                xlabel ("Data Points");
                ylabel ("noise power (dB)");
                grid on;

                strout0 = File_Path;
                strout1 = strcat("Sun Y factor = ",num2str(Sunnoise_maxYdB));
                strout2 =strcat("1dB beamwidth = ",  num2str(Crude1DbBW));
                strout3 = strcat("3dB beamwidth = ",num2str(CrudeHPBW));
                strout4 = strcat("sidelobe 1 = ",num2str(Lsidelobelevel_dB));
                strout5 = strcat("sidelobe 2 = ",num2str(Usidelobelevel_dB));

                waitfor(msgbox({strout0,strout1,strout2,strout3,strout4,strout5},File_Path)); # OK end program

                close all # close open windows

                action = questdlg('Quit or Loop?', 	'What to do next', 	'Quit','Loop','Quit'); ### KA1GT  ### alows looping pack to original filr and running again

                 if (strcmp(action,'Quit'))
                  return
                 endif

endwhile

